#!/bin/bash

set -e  # Exit immediately if a command exits with a non-zero status

# Check if filename is provided
if [ $# -eq 0 ]; then
  echo "Usage: $0 <path-to-log-file.md>"
  echo "Example: $0 ai-logs/2025-03-01-1700-SAR-XX-feature-name.md"
  exit 1
fi

LOG_FILE=$1
AI_LOG_FILE="AI_LOG.md"
CURRENT_DATE=$(date +%Y-%m-%d)

# Check if the input file exists
if [ ! -f "$LOG_FILE" ]; then
  echo "Error: File '$LOG_FILE' not found."
  exit 1
fi

# Check if the AI_LOG.md file exists
if [ ! -f "$AI_LOG_FILE" ]; then
  echo "Error: '$AI_LOG_FILE' not found."
  exit 1
fi

# Extract filename without path and extension for the link text
FILENAME=$(basename "$LOG_FILE" .md)

# Extract required information from the log file
DEVELOPER=$(grep "Developer:" "$LOG_FILE" | sed 's/\*\*Developer:\*\* //')
AI_TOOL=$(grep "Tool name:" "$LOG_FILE" | sed 's/- Tool name: //')
AI_MODEL=$(grep "Model identifier:" "$LOG_FILE" | sed 's/- Model identifier: //')

# Extract the concise summary - directly extract the text after "## Concise Summary" header
# and before the next section header "## Key Accomplishments" (without bullets)
CONCISE_SUMMARY=$(sed -n '/^## Concise Summary$/,/^## Key Accomplishments$/p' "$LOG_FILE" | 
  grep -v "^## Concise Summary" | 
  grep -v "^## Key Accomplishments" | 
  grep -v "^[[:space:]]*-" | 
  tr -d '\n' | 
  sed -e 's/^[[:space:]]*//' -e 's/[[:space:]]*$//')

# Check if all required fields were extracted
if [ -z "$DEVELOPER" ] || [ -z "$AI_TOOL" ] || [ -z "$AI_MODEL" ] || [ -z "$CONCISE_SUMMARY" ]; then
  echo "Error: Failed to extract all required fields from '$LOG_FILE'."
  echo "Developer: $DEVELOPER"
  echo "AI Tool: $AI_TOOL"
  echo "AI Model: $AI_MODEL"
  echo "Concise Summary: $CONCISE_SUMMARY"
  exit 1
fi

# Create the new entry line
NEW_ENTRY="[$FILENAME]($LOG_FILE): $DEVELOPER: $AI_TOOL: $AI_MODEL: $CONCISE_SUMMARY"

# Create a temporary file
TMP_FILE=$(mktemp)

# Add warning header and content to the temp file
cat << EOF > "$TMP_FILE"
<!-- 
IMPORTANT: THIS FILE IS AUTO-GENERATED BY AI
DO NOT MODIFY DIRECTLY - Changes will be overwritten
To make changes, create or update individual log files in ai-logs/ 
and then run update_ai_log.sh to regenerate this file
Last updated: $CURRENT_DATE
-->

# AI Log

$NEW_ENTRY

EOF

# Append existing entries (skipping the header comment and directly to the AI Log title)
sed -n '/^# AI Log/,$p' "$AI_LOG_FILE" | tail -n +3 >> "$TMP_FILE"

# Replace the original file with the temporary file
mv "$TMP_FILE" "$AI_LOG_FILE"

# Make the AI log file read-only to prevent accidental modifications
chmod 444 "$AI_LOG_FILE"

# Add warning header to the individual log file if not already present
if ! grep -q "IMPORTANT: THIS FILE IS AUTO-GENERATED" "$LOG_FILE"; then
  TMP_LOG=$(mktemp)
  cat << EOF > "$TMP_LOG"
<!-- 
IMPORTANT: THIS FILE IS AUTO-GENERATED BY AI
DO NOT MODIFY DIRECTLY - Changes may be overwritten
Generated by: $AI_TOOL ($AI_MODEL)
Date: $CURRENT_DATE
-->

EOF
  cat "$LOG_FILE" >> "$TMP_LOG"
  mv "$TMP_LOG" "$LOG_FILE"
  
  # Make the individual log file read-only as well
  chmod 444 "$LOG_FILE"
fi

echo "Successfully added entry for '$FILENAME' to $AI_LOG_FILE"
echo "Both files have been set to read-only to prevent accidental modifications."
echo "If you need to make changes, use chmod 644 to make them writable first."